Subject: Re: [PATCH 1/2] NET: Re-add VLAN tag for devices incapable of keeping it

From: Patrick McHardy <[email-masked]>
Date: Wed, 07 Nov 2007 00:55:01 +0100

Krzysztof Halasa wrote:
> Patrick McHardy <[email-masked]> writes:
> 
>> I think there is one more case that matters, which is briding
>> from a device with VLAN stripping for a VLAN not configured
>> locally. The tag will be stripped and will be lost for forwarded
>> packets.
> 
> I think we should drop such packets on RX. Anyway we shouldn't
> forward them.

I believe you misunderstand the configuration I was thinking about:

eth0.1000        br0
     |             |
eth0 with VLAN stripping

Its slightly different that I thought though, __vlan_hwaccel_rx
drops packets for unknown vids, so as soon as you configure a VLAN
locally on the same device that is used for a bridge, no VLAN
packets will be forwarded at all.

Slightly inconsistent with how other layered devices work, but
can be avoided by adding the VLAN to br0.